//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

//
// WARNING: Generated file, do not edit by hand!
//

/** \file inst/lw.hh
    \brief Declare the interface of Lw */
#ifndef INST_LW_HH
# define INST_LW_HH

# include "inst/register.hh"
# include "inst/exp.hh"
# include "inst/inst.hh"

namespace inst
{

  /// Declare Lw.
  /** Load the 32-bit quantity at address (offset + base) into 
dest as a signed value.  */
  class Lw:
    public Inst
  {
    /** \name Ctor & dtor.
        \{ */
  public:
    /// Construct a(n) Lw node.
    Lw(const Register &dest, const CountedExp &offset, const Register &base);
    /// Destroy a(n) Lw node.
    virtual ~Lw();
    /** \} */

    /** \name Accessors.
        \{ */
  public:
    /// Return dest
    const Register &		get_dest() const ;
    /// Return dest
    Register &		get_dest() ;
    /// Return offset
    const Exp &		get_offset() const ;
    /// Return offset
    Exp &		get_offset() ;
    /// Return base
    const Register &		get_base() const ;
    /// Return base
    Register &		get_base() ;
    /** \} */

    /** \name Visitors entry point.
        \{ */
  public:
    /// Accept a const visitor \a v.
    virtual void accept(ConstVisitor& v) const;
    /// Accept a non-const visitor \a v.
    virtual void accept(Visitor& v);
    /** \} */

  public:
    /// Print this
    virtual void	write(std::ostream &ostr) const;

  protected:
    Register	dest_;
    CountedExp	offset_;
    Register	base_;
  };

} // namespace inst

# include "inst/lw.hxx"

#endif // !INST_LW_HH
