//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

//
// WARNING: Generated file, do not edit by hand!
//

#ifndef INST_PROGRAM_BUILDER_HH
# define INST_PROGRAM_BUILDER_HH

# include "inst/all.hh"
# include "inst/int_exp.hh"
# include "inst/label_exp.hh"
# include "inst/op_exp.hh"
# include "inst/program.hh"

# include "vm/cpu.hh"

namespace inst
{

  using vm::Cpu;
  
  class ProgramBuilder
  {
  public:
    ProgramBuilder();

  public:
    void reset();

    void set_nop_after_branch(bool nop_after_branch_p);
    
    Program *get();
    
  public:
    void define_inst_label(const misc::unique_string &id);
    void define_data_label(const misc::unique_string &id);

  public:
    void add_byte(int imm);

    void add_half(int imm);

    void add_word(int imm);
    void add_word(LabelExp *l);

    void add_ascii(const std::string *str);
    void add_asciiz(const std::string *str);

    void add_space (int size);

  public:
    void add_add(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Add(*dest, *src1, *src2));
    }
    void add_addu(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Addu(*dest, *src1, *src2));
    }
    void add_addi(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Addi(*dest, *src, imm));
    }
    void add_addiu(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Addiu(*dest, *src, imm));
    }
    void add_sub(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Sub(*dest, *src1, *src2));
    }
    void add_subu(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Subu(*dest, *src1, *src2));
    }
    void	add_abs(Register *dest, Register *);
    void add_mul(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Mul(*dest, *src1, *src2));
    }
    void	add_mul(Register *, Register *, Exp *);
    void add_div(Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Div(*src1, *src2));
    }
    void	add_div(Register *, Register *, Register *);
    void	add_div(Register *, Register *, Exp *);
    void add_divu(Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Divu(*src1, *src2));
    }
    void	add_divu(Register *, Register *, Register *);
    void	add_divu(Register *, Register *, Exp *);
    void	add_rem(Register *dest, Register *, Register *);
    void	add_remu(Register *dest, Register *, Register *);
    void add_sll(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Sll(*dest, *src, imm));
    }
    void add_sllv(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Sllv(*dest, *src1, *src2));
    }
    void add_sra(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Sra(*dest, *src, imm));
    }
    void add_srav(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Srav(*dest, *src1, *src2));
    }
    void add_srl(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Srl(*dest, *src, imm));
    }
    void add_srlv(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Srlv(*dest, *src1, *src2));
    }
    void	add_rol(Register *dest, Register *, Register *);
    void	add_rol(Register *dest, Register *, Exp *);
    void	add_ror(Register *dest, Register *, Register *);
    void	add_ror(Register *dest, Register *, Exp *);
    void add_and(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new And(*dest, *src1, *src2));
    }
    void add_andi(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Andi(*dest, *src, imm));
    }
    void add_or(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Or(*dest, *src1, *src2));
    }
    void add_ori(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Ori(*dest, *src, imm));
    }
    void add_xor(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Xor(*dest, *src1, *src2));
    }
    void add_xori(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Xori(*dest, *src, imm));
    }
    void add_nor(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Nor(*dest, *src1, *src2));
    }
    void	add_nor(Register *dest, Register *, Exp *);
    void	add_seq(Register *dest, Register *, Register *);
    void	add_seq(Register *dest, Register *, Exp *);
    void	add_sne(Register *dest, Register *, Register *);
    void	add_sne(Register *dest, Register *, Exp *);
    void	add_sge(Register *dest, Register *, Register *);
    void	add_sge(Register *dest, Register *, Exp *);
    void	add_sgeu(Register *dest, Register *, Register *);
    void	add_sgeu(Register *dest, Register *, Exp *);
    void	add_sgt(Register *dest, Register *, Exp *);
    void	add_sgtu(Register *dest, Register *, Exp *);
    void	add_sle(Register *dest, Register *, Register *);
    void	add_sle(Register *dest, Register *, Exp *);
    void	add_sleu(Register *dest, Register *, Register *);
    void	add_sleu(Register *dest, Register *, Exp *);
    void add_slt(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Slt(*dest, *src1, *src2));
    }
    void add_sltu(Register *dest, Register *src1, Register *src2)
    {
      program_->text_section().add_inst (new Sltu(*dest, *src1, *src2));
    }
    void add_slti(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Slti(*dest, *src, imm));
    }
    void add_sltiu(Register *dest, Register *src, Exp *imm)
    {
      program_->text_section().add_inst (new Sltiu(*dest, *src, imm));
    }
    void add_beq(Register *src1, Register *src2, Exp *label)
    {
      program_->text_section().add_inst (new Beq(*src1, *src2, label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void	add_beq(Register *, Exp *, Exp *);
    void add_bne(Register *src1, Register *src2, Exp *label)
    {
      program_->text_section().add_inst (new Bne(*src1, *src2, label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void	add_bne(Register *, Exp *, Exp *);
    void	add_bge(Register *, Register *, Exp *);
    void	add_bge(Register *, Exp *, Exp *);
    void	add_bgeu(Register *, Register *, Exp *);
    void	add_bgeu(Register *, Exp *, Exp *);
    void add_bgez(Register *src, Exp *label)
    {
      program_->text_section().add_inst (new Bgez(*src, label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void add_bgezal(Register *src, Exp *label)
    {
      program_->text_section().add_inst (new Bgezal(*src, label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void	add_bgt(Register *, Register *, Exp *);
    void	add_bgt(Register *, Exp *, Exp *);
    void	add_bgtu(Register *, Register *, Exp *);
    void	add_bgtu(Register *, Exp *, Exp *);
    void add_bgtz(Register *src, Exp *label)
    {
      program_->text_section().add_inst (new Bgtz(*src, label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void	add_ble(Register *, Register *, Exp *);
    void	add_ble(Register *, Exp *, Exp *);
    void	add_bleu(Register *, Register *, Exp *);
    void	add_bleu(Register *, Exp *, Exp *);
    void add_blez(Register *src, Exp *label)
    {
      program_->text_section().add_inst (new Blez(*src, label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void	add_blt(Register *, Register *, Exp *);
    void	add_blt(Register *, Exp *, Exp *);
    void	add_bltu(Register *, Register *, Exp *);
    void	add_bltu(Register *, Exp *, Exp *);
    void add_bltz(Register *src, Exp *label)
    {
      program_->text_section().add_inst (new Bltz(*src, label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void add_bltzal(Register *src, Exp *label)
    {
      program_->text_section().add_inst (new Bltzal(*src, label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void add_j(Exp *label)
    {
      program_->text_section().add_inst (new Jmp(label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void add_jal(Exp *label)
    {
      program_->text_section().add_inst (new Jal(label));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void add_jr(Register *dest)
    {
      program_->text_section().add_inst (new Jr(*dest));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void add_jalr(Register *dest)
    {
      program_->text_section().add_inst (new Jalr(*dest));
      if (nop_after_branch_p_)
	program_->text_section().
	  add_inst (new Sll(Register(Register::general, Cpu::zero), 
			    Register(Register::general, Cpu::zero), 
			    new IntExp(0)));
    }
    void add_lb(Register *dest, Exp *offset, Register *base)
    {
      program_->text_section().add_inst (new Lb(*dest, offset, *base));
    }
    void add_lbu(Register *dest, Exp *offset, Register *base)
    {
      program_->text_section().add_inst (new Lbu(*dest, offset, *base));
    }
    void add_lw(Register *dest, Exp *offset, Register *base)
    {
      program_->text_section().add_inst (new Lw(*dest, offset, *base));
    }
    void add_lui(Register *dest, Exp *imm)
    {
      program_->text_section().add_inst (new Lui(*dest, imm));
    }
    void	add_la(Register *, Exp *, Register *);
    void	add_la(Register *, Exp *);
    void add_sb(Register *src, Exp *offset, Register *base)
    {
      program_->text_section().add_inst (new Sb(*src, offset, *base));
    }
    void add_sw(Register *src, Exp *offset, Register *base)
    {
      program_->text_section().add_inst (new Sw(*src, offset, *base));
    }
    void add_mfhi(Register *dest)
    {
      program_->text_section().add_inst (new Mfhi(*dest));
    }
    void add_mflo(Register *dest)
    {
      program_->text_section().add_inst (new Mflo(*dest));
    }
    void add_mthi(Register *src)
    {
      program_->text_section().add_inst (new Mthi(*src));
    }
    void add_mtlo(Register *src)
    {
      program_->text_section().add_inst (new Mtlo(*src));
    }
    void add_mfc0(Register *dest, Register *src)
    {
      program_->text_section().add_inst (new Mfc0(*dest, *src));
    }
    void add_mtc0(Register *dest, Register *src)
    {
      program_->text_section().add_inst (new Mtc0(*dest, *src));
    }
    void add_syscall()
    {
      program_->text_section().add_inst (new Syscall());
    }

  protected:
    Program *program_;
    bool nop_after_branch_p_;
  };

} // namespace inst

# include "inst/program_builder.hxx"

#endif // !INST_PROGRAM_BUILDER_HH
