//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004, 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

//
// WARNING: Generated file, do not edit by hand!
//

#ifndef INST_PROGRAM_SOLVER_HH
# define INST_PROGRAM_SOLVER_HH

# include "inst/fwd.hh"
# include "inst/exp-visitor.hh"
# include "inst/visitor.hh"
# include "inst/all.hh"
# include "inst/program.hh"

namespace inst
{

  class ProgramSolver:
    protected Visitor, 
    protected ExpVisitor
  {
  public:
    ProgramSolver();
    virtual ~ProgramSolver();

  public:
    void set_max_callee_save(int max_callee_save);
    void set_max_caller_save(int max_caller_save);
    void set_max_args(int max_args);

    void enable_unlimited_regs(bool flag = true);

  public:
    void solve(Program &program);

  protected:
    void solve_exp(Exp &exp);

    virtual void visit(IntExp &i);
    virtual void visit(LabelExp &l);
    virtual void visit(OpExp &o);

  protected:
    void solve_cpu_register(Register &reg) const;
    void solve_cop_register(Register &reg) const;

  protected:
    virtual void	visit(Add &);
    virtual void	visit(Addu &);
    virtual void	visit(Addi &);
    virtual void	visit(Addiu &);
    virtual void	visit(Sub &);
    virtual void	visit(Subu &);
    virtual void	visit(Mul &);
    virtual void	visit(Div &);
    virtual void	visit(Divu &);
    virtual void	visit(Sll &);
    virtual void	visit(Sllv &);
    virtual void	visit(Sra &);
    virtual void	visit(Srav &);
    virtual void	visit(Srl &);
    virtual void	visit(Srlv &);
    virtual void	visit(And &);
    virtual void	visit(Andi &);
    virtual void	visit(Or &);
    virtual void	visit(Ori &);
    virtual void	visit(Xor &);
    virtual void	visit(Xori &);
    virtual void	visit(Nor &);
    virtual void	visit(Slt &);
    virtual void	visit(Sltu &);
    virtual void	visit(Slti &);
    virtual void	visit(Sltiu &);
    virtual void	visit(Beq &);
    virtual void	visit(Bne &);
    virtual void	visit(Bgez &);
    virtual void	visit(Bgezal &);
    virtual void	visit(Bgtz &);
    virtual void	visit(Blez &);
    virtual void	visit(Bltz &);
    virtual void	visit(Bltzal &);
    virtual void	visit(Jmp &);
    virtual void	visit(Jal &);
    virtual void	visit(Jr &);
    virtual void	visit(Jalr &);
    virtual void	visit(Lb &);
    virtual void	visit(Lbu &);
    virtual void	visit(Lw &);
    virtual void	visit(Lui &);
    virtual void	visit(Sb &);
    virtual void	visit(Sw &);
    virtual void	visit(Mfhi &);
    virtual void	visit(Mflo &);
    virtual void	visit(Mthi &);
    virtual void	visit(Mtlo &);
    virtual void	visit(Mfc0 &);
    virtual void	visit(Mtc0 &);
    virtual void	visit(Syscall &);

  protected:
    Program *program_;
    int pc_;

    int max_callee_save_;
    int max_caller_save_;
    int max_args_;

    bool unlimited_regs_enabled_;
  };

} // namespace inst

# include "inst/program_solver.hxx"

#endif // !INST_PROGRAM_SOLVER_HH

