//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#include "inst/section.hh"

namespace inst
{

  Section::~Section()
  {
//     for (label_set_type::iterator
// 	   it = sorted_labels_.begin(); it != sorted_labels_.end(); ++it)
//       delete *it;
  }

  bool
  Section::register_label(Label *label)
  {
    label_set_type::const_iterator it(sorted_labels_.find(label));
    if (it == sorted_labels_.end()
	|| *(*it) < *label)
      {
	it = sorted_labels_.insert(it, label);
	return true;
      }
    return false;
  }

} // namespace inst
