//
// test-unique_string.cc: test string uniquifier
// Copyright (C) 2005 Benoit Perrot <benoit@lrde.epita.fr>
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// It is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#include "misc/contract.hh"
#include "misc/unique_string.hh"

int
main()
{
  misc::unique_string foo0("foo");
  misc::unique_string foo1("foo");
  misc::unique_string bar("bar");

  assertion(misc::unique_string::pool_size() == 2);
  assertion(*foo0 == "foo");
  assertion(foo0 == foo1);
  assertion(foo0 != bar);
  assertion(bar < foo1);

  return 0;
}
