//
// unique_string.cc: string uniquifier
// Copyright (C) 2005 Benoit Perrot <benoit@lrde.epita.fr>
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// It is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

#include "misc/unique_string.hh"
#include "misc/contract.hh"

namespace misc
{

  unique_string::string_to_unique_type unique_string::pool_;

  unique_string::string_to_unique_type::const_iterator
  unique_string::insert_in_pool(const std::string &str)
  {
    string_to_unique_type::const_iterator it(pool_.find(str));
    if (it == pool_.end() || it->compare(str))
      it = pool_.insert(it, str);
    return it;
  }

} // namespace misc
