//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004, 2009 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

#include <cstdlib>

#include <string>
#include <iostream>

#define NOLIMIPS_CC_
#include "common.hh"
#include "modules.hh"

#include "parse/libparse.hh"

#include "task/task_register.hh"

exit_type exit_status = exit_success;
const char* program_name;

int	main(int argc, char* argv[])
{
  program_name = argv[0];

  filename = task::TaskRegister::instance().parse_args(argc, argv);
  if (task::TaskRegister::instance().enabled_tasks ().size () == 0)
    task::TaskRegister::instance().enable_task("execute");
  
  exit_status = exit_success;
  task::TaskRegister::instance().execute();
  if (exit_status != exit_success)
    exit (exit_status);

  return exit_status;
}
