//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2004 Akim Demaille <akim@epita.fr> and
//		      Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//

#include "task/boolean_task.hh"

namespace task
{

  BooleanTask::BooleanTask(bool &flag,
			   const std::string& option,
			   const std::string& module_name,
			   const std::string& desc,
			   const std::string& deps):
    Task(option, module_name, desc, deps),
    flag_(flag)
  {}

  void
  BooleanTask::execute (void) const
  {
    flag_ = true;
  }

} //namespace task
